package sk.upjs.ics.kniznica;

import java.util.ArrayList;
import java.util.List;

public class PamatovaPozicovna implements Pozicovna {
	
	private List<Kniha> zoznamKnih = new ArrayList<Kniha>();
	
	private List<Kniha> zoznamPozicanychKnih = new ArrayList<Kniha>();
	
	public PamatovaPozicovna() {
		Kniha harryPotter = new Kniha();
		harryPotter.setAutor("J. K. Rowling");
		harryPotter.setNazov("HP a vazen z Azkabanu");
		harryPotter.setIsbn(12345);
		harryPotter.setPocetStran(687);
		harryPotter.setVydavatel("Ikar");
		harryPotter.setZaner("fantasy");
		
		Kniha ehk = new Kniha();
		ehk.setAutor("Elias, Horvath, Kajan");
		ehk.setNazov("Zbierka uloh z vyssej matematiky");
		ehk.setIsbn(9876);
		ehk.setPocetStran(300);
		ehk.setVydavatel("SAV");
		ehk.setZaner("zbierka uloh");

		Kniha dominikDan = new Kniha();
		dominikDan.setAutor("Dominik Dn");
		dominikDan.setNazov("Mucha");
		dominikDan.setIsbn(1234);
		dominikDan.setPocetStran(280);
		dominikDan.setVydavatel("Ikar");
		dominikDan.setZaner("detektvka");

		zaeviduj(harryPotter);
		zaeviduj(ehk);
		zaeviduj(dominikDan);
	}
	
	@Override
	public boolean jePozicana(Kniha kniha) {
		return zoznamPozicanychKnih.contains(kniha);
	}

	@Override
	public boolean jeEvidovana(Kniha kniha) {
		return zoznamKnih.contains(kniha);
	}

	@Override
	public boolean vypozicaj(Kniha kniha) {
		if(jeEvidovana(kniha) && !jePozicana(kniha)) {		
			zoznamPozicanychKnih.add(kniha);
			return true;
		}
		return false;
	}

	@Override
	public void vyrad(Kniha kniha) {
		zoznamKnih.remove(kniha);
	}


	@Override
	public void vrat(Kniha kniha) {
		zoznamPozicanychKnih.remove(kniha);		
	}

	@Override
	public void zaeviduj(Kniha kniha) {
		zoznamKnih.add(kniha);
	}

	@Override
	public List<Kniha> vyhladajPodlaAutora(String autor) {
		List<Kniha> najdeneKnihy = new ArrayList<Kniha>();
		for (Kniha kniha : zoznamKnih) {
			if(kniha.getAutor().equals(autor)) {
				najdeneKnihy.add(kniha);
			}
		}
		
		return najdeneKnihy;
	}

	@Override
	public List<Kniha> vyhladajPodlaNazvu(String nazov) {
		List<Kniha> najdeneKnihy = new ArrayList<Kniha>();
		for (Kniha kniha : zoznamKnih) {
			if(kniha.getNazov().contains(nazov)) {
				najdeneKnihy.add(kniha);
			}
		}
		
		return najdeneKnihy;
	}

	@Override
	public int dajPocetKnih() {
		return zoznamKnih.size();
	}

	@Override
	public List<Kniha> dajVsetkyKnihy() {
		return zoznamKnih;
	}

}
